// ==UserScript==
// @exclude *
// ==/UserScript==

var youtube_com_embed = {
  getYoutubeLinks: function (request, callback)
  {
    function callback_links(links, title, subtitles, duration)
    {

      if ( links && (engine.language.lang === 'ru' || engine.language.lang === 'uk') && navigator.platform.indexOf('Win') !== -1) {
        links['ummy'] = 'ummy:www.youtube.com/watch?v=' + request.extVideoId;
      }

      var response = {
        action: request.action,
        extVideoId: request.extVideoId,
        links: links,
        title: title,
        subtitles: subtitles,
        duration: duration,
        checkLinks: null
      };

      if(request.checkLinks && links)
      {
        youtube_com_embed.checkYoutubeLinks(links, function(checkUrl, isValid, status){
          response.checkLinks = isValid;
          callback(response);
        });
        return;
      }

      callback(response);
    }

    youtube_com_embed._getYoutubeLinks(request.url, request.extVideoId, request.checkSubtitles, callback_links);
  },

  _getYoutubeLinks: function (eurl, videoId, checkSubtitles, callback_) {
    var links = null, title = '', duration = '';
    if (!eurl) {
      eurl = 'http://www.youtube.com/watch?v='+videoId;
    }
    eurl = encodeURIComponent(eurl);
    var url = 'http://www.youtube.com/get_video_info?video_id=' + videoId +
      '&asv=3&eurl=' + eurl + '&el=info&sts=15956';

    var embed = true;
    var callback = function(links, title, subtitles, duration) {
      if(links || !embed)
      {
        callback_(links, title, subtitles, duration);
      }
      else
      {
        embed = false;
        url = 'http://www.youtube.com/watch?v=' + videoId;
        mono.ajax({
          url: url,
          success: getYoutubeLinks_,
          error: getYoutubeLinks_
        });
      }
    };

    mono.ajax({
      url: url,
      success: getYoutubeLinks_,
      error: getYoutubeLinks_
    });

    function getYoutubeLinks_(r, xhr) {
      if (xhr !== undefined) {
        r = xhr;
      }
      var cb = function() {
        if(checkSubtitles)
        {
          youtube_com_embed.checkYoutubeSubtitles(videoId, function(subtitles){
            callback(links, title, subtitles, duration);
          });
        }
        else
          callback(links, title, null, duration);
      };

      if (r.status !== 200 || !r.responseText) {
        return cb();
      }

      var dashUrl;
      try {
        var getParam = function(str, param, number) {
          var re = new RegExp('(?:^|&)' + param + '=([^\\s\\&\\"]+)', 'i');
          if(!embed)
          {
            re = new RegExp('\\"' + param + '\\"\\s*:\\s*\\"([^\\"]+)\\"', 'i');
            if(number)
              re = new RegExp('\\"' + param + '\\"\\s*:\\s*\\"?(\\d+)', 'i');
          }

          var m = str.match(re);
          if(m && m.length > 1)
          {
            if(embed)
              return decodeURIComponent(m[1]);

            if (m[1] && m[1].substr(m[1].length - 1) === '\\') {
              m[1] += '\\';
            }

            var json = '{"v": "' + m[1] + '"}';
            var obj = JSON.parse(json);
            if(obj && obj.v)
              return obj.v;
          }

          return '';
        };

        var baseUrl = '',
          adaptiveFmts = getParam(r.responseText, 'adaptive_fmts'),
          title = getParam(r.responseText, 'title'),
          length_seconds = getParam(r.responseText, 'length_seconds', true),
          fmtMap = getParam(r.responseText, '(?:fmt_url_map|url_encoded_fmt_stream_map)');

        dashUrl = getParam(r.responseText, 'dashmpd');

        if(!embed)
          fmtMap = fmtMap.split('\\u0026').join('&');

        if(fmtMap.search(/url%3dhttp/i) > -1)
          fmtMap = decodeURIComponent(fmtMap);

        var titleParam = '';
        if(title)
        {
          title = title.replace(/\+/g, '%20');
          title = decodeURIComponent(title).
            replace(/[\x2F\x5C\x3A\x7C]/g, '-').
            replace(/[\x2A\x3F]/g, '').
            replace(/\x22/g, '\'').
            replace(/\x3C/g, '(').
            replace(/\x3E/g, ')').
            replace(/(?:^\s+)|(?:\s+$)/g, '');

          // TODO: Fix when fix fileName.modify
          titleParam = '&title=' + encodeURIComponent( title );
        }

        if(length_seconds)
          duration = length_seconds;

        var lks = youtube_com_embed.parseYoutubeFmtMap(fmtMap, titleParam, baseUrl);
        if(adaptiveFmts)
        {
          var adaptive_links = youtube_com_embed.parseYoutubeFmtMap(adaptiveFmts, titleParam, baseUrl);

          for (var i in adaptive_links) {
            if(!lks[i])
              lks[i] = adaptive_links[i];
          }
        }

        // Deprecated
        // findYoutubeAvailableLinks(lks, baseUrl, dashUrl, adaptiveFmts, titleParam);

        if(lks)
          links = lks;
      }
      finally {
        youtube_com_embed.getYouTubeDashLinks(links, dashUrl, function(_links) {
          if (_links) {
            links = _links;
          }
          cb();
        });
      }
    }
  },

  checkYoutubeLinks: function (links, callback)
  {
    var checkItags = ['18', '34', '35'], checkUrl = '';
    for(var i = 0; i < checkItags.length; i++)
    {
      if(links[checkItags[i]])
      {
        checkUrl = links[checkItags[i]];
        break;
      }
    }

    if(checkUrl)
    {
      mono.ajax({
        type: 'HEAD',
        url: checkUrl,
        success: function(data, xhr) {
          callback(checkUrl, true, xhr.status);
        },
        error: function(xhr) {
          callback(checkUrl, false, xhr.status);
        }
      });
      return;
    }

    callback();
  },

  checkYoutubeSubtitles: function (videoId, callback)
  {
    var url = 'http://video.google.com/timedtext?hl=en&v=' + videoId +
      '&type=list&tlangs=1';

    mono.ajax({
      url: url,
      mimeType: 'text/xml',
      success: function(data, xhr) {
        var result = false;
        if (xhr.responseXML) {
          if(xhr.responseXML.querySelector('target, track')) {
            result = true;
          }
        }
        callback(result);
      },
      error: function() {
        callback(false);
      }
    });
  },

  parseYoutubeFmtMap: function (fmtMap, titleParam, baseUrl)
  {
    if(!fmtMap)
      return;

    var l = {};

    fmtMap = fmtMap.split(',');
    for(var i = 0; i < fmtMap.length; ++i)
    {
      var query = mono.parseUrlParams(fmtMap[i]);
      if(query.url)
      {
        query.url = decodeURIComponent(query.url);
        if(query.url.search(/(\?|&)sig(nature)?=/i) == -1)
        {
          if(query.sig)
            query.url += '&signature=' + query.sig;
          else if(query.signature)
            query.url += '&signature=' + query.signature;
          else if(query.s)
            query.url += '&signature=' + youtube_com_embed.youtubeSignatureDecipher(query.s);
        }

        if(query.url.search(/(\?|&)itag=/i) == -1)
        {
          if(query.itag)
            query.url += '&itag=' + query.itag;
        }

        var fmt = query.url.match(/(?:\?|&)itag=(\d+)/i);
        if(fmt && fmt.length > 1)
        {
          fmt = fmt[1];

          query.url = query.url.replace(/(\?|&)sig=/i, '$1signature=').
            replace(/\\u0026/ig, '&').replace(/\\\//g, '/');

          l[fmt] = query.url;

          if(titleParam)
            l[fmt] += titleParam;

          if(!baseUrl)
          {
            var m = query.url.match(/^(https?:\/\/[^\?]+\?)/);
            if(m && m.length > 1)
              baseUrl = m[1];
          }
        }
      }
    }

    return l;
  },

  getYouTubeDashLinks: function(links, dashmpd, cb) {
    if (!dashmpd) {
      return cb();
    }
    if (dashmpd.indexOf('yt_live_broadcast') !== -1) {
      return cb();
    }
    var signature_pos = dashmpd.indexOf('signature');
    if (signature_pos === -1) {
      var s_pos = dashmpd.indexOf('/s/');
      if (s_pos === -1) {
        return cb();
      }
      s_pos += 3;
      var s_end = dashmpd.indexOf('/', s_pos);
      if (s_end === -1) {
        s_end = dashmpd.length;
      }
      var s = dashmpd.substr( s_pos, s_end - s_pos );
      var signature = youtube_com_embed.youtubeSignatureDecipher(s);
      if (signature === s) {
        return cb();
      }
      dashmpd = dashmpd.substr(0, s_pos - 2) + 'signature/' + signature + dashmpd.substr(s_end);
    }
    mono.ajax({
      url: dashmpd,
      mimeType: 'text/xml',
      success: function(data, xhr) {
        if (!xhr.responseXML) {
          return cb();
        }
        youtube_com_embed.parseDash( xhr.responseXML, links, cb);
      },
      error: function() {
        cb();
      }
    });
  },

  parseDash: function(xml, links, cb) {
    var elList = xml.querySelectorAll('Representation');
    if (!links) {
      links = {};
    }
    for (var i = 0, el; el = elList[i]; i++) {
      var itag = el.getAttribute('id');
      if (links[itag] !== undefined) {
        continue;
      }
      var baseurl = el.querySelector('BaseURL');
      if (baseurl === null) {
        continue;
      }
      var url = baseurl.textContent;
      links[itag] = url;
    }
    cb(links);
  },

  youtubeSignatureDecipher: function (sig) {
    function swap(a, b)
    {
      var t = a[0];
      a[0] = a[b % a.length];
      a[b] = t;
    }

    var s = sig.split('');
    swap(s, 43);
    swap(s, 2);
    swap(s, 54);
    s = s.reverse();
    swap(s, 8);
    s = s.slice(1);
    return s.join('');
  }
};

if (typeof window === 'undefined') {
  exports.init = function(_mono, _engine, _navigator) {
    mono = _mono;
    engine = _engine;
    navigator = _navigator;
    return youtube_com_embed;
  };
} else {
  engine.modules.youtube = youtube_com_embed;
}